#include <IRremote.h> 

const int EnA = 6;
const int IN1 = 9; 
const int IN2 = 10; 
const int EnB = 7;
const int IN3 = 4; 
const int IN4 = 5; 
/* ULTRASCHALL VARIABLEN */
int trigger = 2; 
int echo = 3; 
long dauer = 0; 
long entfernung = 0; 
/* INFRAROT CODE VARIABLEN; BEFEHLE */
int RECV_PIN = 11;  
IRrecv irrecv(RECV_PIN);
decode_results results;

void setup() {
  Serial.begin(9600);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  pinMode(EnA, OUTPUT);
  pinMode(EnB, OUTPUT);

  /* ULTRASCHALLMODUL */
  pinMode(trigger, OUTPUT); 
  pinMode(echo, INPUT); 

  /* INFRAROT */
  pinMode (13, OUTPUT);
  irrecv.enableIRIn(); 
}

void loop() {
  digitalWrite(EnA, HIGH);
  int pwm = 250;
  analogWrite(IN1, pwm);
  digitalWrite(IN2, LOW);

  digitalWrite(EnB, HIGH);
  int pwm = 250;
  analogWrite(IN3, pwm);
  digitalWrite(IN4, LOW);

  /* void VorwaertsRechts(OSCMessage * _mes) {
    float v1 = _mes->getArgFloat(0);
    float v2 = _mes->getArgFloat(1);
    
    analogWrite(EnA, v1);
    //Rechts
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);

    analogWrite(EnB, v2);
    //Links
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    }

    void VorwaertsLinks(OSCMessage * _mes) {
    float v1 = _mes->getArgFloat(0);
    float v2 = _mes->getArgFloat(1);

    analogWrite(EnA, v2);
    //Rechts
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);

    analogWrite(EnB, v1);
    //Links
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    }*/

    void Stopp(OSCMessage * _mes) {

    digitalWrite(EnA, LOW);
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, LOW);
    digitalWrite(EnB, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, LOW);
    } 

  /* ULTRASCHALLMODUL */
    digitalWrite(trigger, LOW); 
    delay(5); 
    digitalWrite(trigger, HIGH); 
    delay(10); 
    digitalWrite(trigger, LOW);
    dauer = pulseIn(echo, HIGH); 
    entfernung = (dauer / 2) * 0.03432; 
    if (entfernung <= 80)
    {
    digitalWrite(JACK,LOW); //langsamer werden  ... ÜBERARBEITUNG
    }
    else {  
    digitalWrite(JACK,HIGH);  //fahren...  ÜBERARBEITUNG
    }
    delay(1000);
    }

  /* INFRAROT */
    if (irrecv.decode(&results)) { 
    Serial.println(results.value, DEC); 
    irrecv.resume();  
    }
    }

